Index: doc/freediameter.conf.sample
===================================================================
--- doc/freediameter.conf.sample	(revision 9)
+++ doc/freediameter.conf.sample	(revision 10)
@@ -129,4 +129,5 @@
 TwTimer = 6;
 NoRelay;
-#LoadExtension = "extensions/sample.fdx";
-LoadExtension = "extensions/sample.fdx":"conf/sample.conf";
+LoadExtension = "extensions/dbg_monitor.fdx";
+LoadExtension = "extensions/dict_nasreq.fdx";
+LoadExtension = "extensions/dict_eap.fdx";
Index: extensions/CMakeLists.txt
===================================================================
--- extensions/CMakeLists.txt	(revision 9)
+++ extensions/CMakeLists.txt	(revision 10)
@@ -18,13 +18,13 @@
 ####
 # Diameter applications dictionary
-# OPTION(BUILD_DICT_NASREQ "Build NASREQ (RFC4005) Dictionary definitions?" ON)
-# 	IF (BUILD_DICT_NASREQ)
-# 	   SUBDIRS(dict_nasreq)
-# 	ENDIF (BUILD_DICT_NASREQ)
+OPTION(BUILD_DICT_NASREQ "Build NASREQ (RFC4005) Dictionary definitions?" ON)
+	IF (BUILD_DICT_NASREQ)
+	   SUBDIRS(dict_nasreq)
+	ENDIF (BUILD_DICT_NASREQ)
 
-# OPTION(BUILD_DICT_EAP "Build Diameter EAP (RFC4072) Dictionary definitions?" ON)
-# 	IF (BUILD_DICT_EAP)
-# 	   SUBDIRS(dict_eap)
-# 	ENDIF (BUILD_DICT_EAP)
+OPTION(BUILD_DICT_EAP "Build Diameter EAP (RFC4072) Dictionary definitions?" ON)
+	IF (BUILD_DICT_EAP)
+	   SUBDIRS(dict_eap)
+	ENDIF (BUILD_DICT_EAP)
 
 
@@ -59,8 +59,13 @@
 # Debug / development extensions
 
-OPTION(BUILD_SAMPLE "Build sample? (Simple extension to demonstrate extension mechanism, for developpers only)" OFF)
+OPTION(BUILD_SAMPLE "Build sample.fdx? (Simple extension to demonstrate extension mechanism, for developpers only)" OFF)
 	IF (BUILD_SAMPLE)
 	   SUBDIRS(_sample)
 	ENDIF (BUILD_SAMPLE)
+
+OPTION(BUILD_MONITOR "Build monitor.fdx? (display periodical debug information on the console)" OFF)
+	IF (BUILD_MONITOR)
+	   SUBDIRS(dbg_monitor)
+	ENDIF (BUILD_MONITOR)
 
 # OPTION(BUILD_RT_ANY "Build rt_any? (Routing extension sending message to any peer available, for testing purpose only)" OFF)
Index: extensions/_sample/CMakeLists.txt
===================================================================
--- extensions/_sample/CMakeLists.txt	(revision 9)
+++ extensions/_sample/CMakeLists.txt	(revision 10)
@@ -3,3 +3,3 @@
 
 # Compile as a module
-FD_ADD_EXTENSION(sample sample.c fini.c)
+FD_ADD_EXTENSION(dbg_sample sample.c fini.c)
Index: extensions/_sample/fini.c
===================================================================
--- extensions/_sample/fini.c	(revision 9)
+++ extensions/_sample/fini.c	(revision 10)
@@ -34,11 +34,11 @@
 *********************************************************************************************************/
 
-/* Sample extension exit point */
-
 #include <freeDiameter/extension.h>
 
+/* The function MUST be called this */
 void fd_ext_fini(void)
 {
-	fd_log_debug("Extension is terminated... Bye!\n");
+	/* This code is executed when the daemon is exiting; cleanup management should be placed here */
+	TRACE_DEBUG(INFO, "Extension is terminated... Bye!");
 	return ;
 }
Index: extensions/_sample/sample.c
===================================================================
--- extensions/_sample/sample.c	(revision 9)
+++ extensions/_sample/sample.c	(revision 10)
@@ -45,8 +45,11 @@
 static int sample_main(char * conffile)
 {
+	/* The debug macro from main tree can be used the same way */
 	TRACE_ENTRY("%p", conffile);
 	
-	fprintf(stdout, "I am extension " __FILE__ " running on host %s\n", fd_g_config->diam_id);
+	/* This is how we access daemon's global vars */
+	fprintf(stdout, "I am extension " __FILE__ " running on host %s.", fd_g_config->cnf_diamid);
 	
+	/* The configuration file name is received in the conffile var. It's up to extension to parse it */
 	if (conffile) {
 		fprintf(stdout, "I should parse my configuration file there: %s\n", conffile);
@@ -55,6 +58,6 @@
 	}
 	
-	/* Use the dictionary for test */
-	fd_log_debug("Let's create that 'Example-AVP'...\n");
+	/* Functions from the libfreediameter can also be used as demonstrated here: */
+	TRACE_DEBUG(INFO, "Let's create that 'Example-AVP'...");
 	{
 		struct dict_object * origin_host_avp = NULL;
@@ -64,21 +67,26 @@
 		struct dict_avp_data example_avp_data = { 999999, 0, "Example-AVP", AVP_FLAG_VENDOR , 0, AVP_TYPE_GROUPED };
 
-		CHECK_FCT( fd_dict_search ( fd_g_config->g_dict, DICT_AVP, AVP_BY_NAME, "Origin-Host", &origin_host_avp, ENOENT));
-		CHECK_FCT( fd_dict_search ( fd_g_config->g_dict, DICT_AVP, AVP_BY_NAME, "Session-Id", &session_id_avp, ENOENT));
+		CHECK_FCT( fd_dict_search ( fd_g_config->cnf_dict, DICT_AVP, AVP_BY_NAME, "Origin-Host", &origin_host_avp, ENOENT));
+		CHECK_FCT( fd_dict_search ( fd_g_config->cnf_dict, DICT_AVP, AVP_BY_NAME, "Session-Id", &session_id_avp, ENOENT));
 		
-		CHECK_FCT( fd_dict_new ( fd_g_config->g_dict, DICT_AVP, &example_avp_data , NULL, &example_avp_avp ));
+		CHECK_FCT( fd_dict_new ( fd_g_config->cnf_dict, DICT_AVP, &example_avp_data , NULL, &example_avp_avp ));
 		
 		rule_data.rule_avp = origin_host_avp;
 		rule_data.rule_min = 1;
 		rule_data.rule_max = 1;
-		CHECK_FCT( fd_dict_new ( fd_g_config->g_dict, DICT_RULE, &rule_data, example_avp_avp, NULL ));
+		CHECK_FCT( fd_dict_new ( fd_g_config->cnf_dict, DICT_RULE, &rule_data, example_avp_avp, NULL ));
 		
 		rule_data.rule_avp = session_id_avp;
 		rule_data.rule_min = 1;
 		rule_data.rule_max = -1;
-		CHECK_FCT( fd_dict_new ( fd_g_config->g_dict, DICT_RULE, &rule_data, example_avp_avp, NULL ));
+		CHECK_FCT( fd_dict_new ( fd_g_config->cnf_dict, DICT_RULE, &rule_data, example_avp_avp, NULL ));
+		
+		fd_dict_dump_object(example_avp_avp);
 	}
-	fd_log_debug("'Example-AVP' created without error\n");
+	TRACE_DEBUG(INFO, "'Example-AVP' created without error\n");
 	
+	/* The initialization function returns an error code with the standard POSIX meaning (ENOMEM, and so on) */
 	return 0;
 }
+
+/* See file fini.c for an example of destructor */
Index: extensions/dbg_monitor/CMakeLists.txt
===================================================================
--- extensions/dbg_monitor/CMakeLists.txt	(revision 10)
+++ extensions/dbg_monitor/CMakeLists.txt	(revision 10)
@@ -0,0 +1,3 @@
+# Monitoring extension
+PROJECT("Monitor extension" C)
+FD_ADD_EXTENSION(dbg_monitor monitor.c)
Index: extensions/dbg_monitor/monitor.c
===================================================================
--- extensions/dbg_monitor/monitor.c	(revision 10)
+++ extensions/dbg_monitor/monitor.c	(revision 10)
@@ -0,0 +1,96 @@
+/*********************************************************************************************************
+* Software License Agreement (BSD License)                                                               *
+* Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
+*													 *
+* Copyright (c) 2009, WIDE Project and NICT								 *
+* All rights reserved.											 *
+* 													 *
+* Redistribution and use of this software in source and binary forms, with or without modification, are  *
+* permitted provided that the following conditions are met:						 *
+* 													 *
+* * Redistributions of source code must retain the above 						 *
+*   copyright notice, this list of conditions and the 							 *
+*   following disclaimer.										 *
+*    													 *
+* * Redistributions in binary form must reproduce the above 						 *
+*   copyright notice, this list of conditions and the 							 *
+*   following disclaimer in the documentation and/or other						 *
+*   materials provided with the distribution.								 *
+* 													 *
+* * Neither the name of the WIDE Project or NICT nor the 						 *
+*   names of its contributors may be used to endorse or 						 *
+*   promote products derived from this software without 						 *
+*   specific prior written permission of WIDE Project and 						 *
+*   NICT.												 *
+* 													 *
+* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED *
+* WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A *
+* PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR *
+* ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 	 *
+* LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 	 *
+* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR *
+* TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF   *
+* ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.								 *
+*********************************************************************************************************/
+
+/* Monitoring extension:
+ - periodically display queues and peers information
+ - upon SIGUSR1, display additional debug information
+ */
+
+#include <freeDiameter/extension.h>
+#include <signal.h>
+
+static int 	 monitor_main(char * conffile);
+
+EXTENSION_ENTRY("monitor", monitor_main);
+
+/* Function called on receipt of SIGUSR1 */
+static void got_sig(int signal)
+{
+	CHECK_FCT_DO(fd_event_send(fd_g_config->cnf_main_ev, FDEV_DUMP_DICT, NULL), /* continue */);
+	CHECK_FCT_DO(fd_event_send(fd_g_config->cnf_main_ev, FDEV_DUMP_CONFIG, NULL), /* continue */);
+	CHECK_FCT_DO(fd_event_send(fd_g_config->cnf_main_ev, FDEV_DUMP_EXT, NULL), /* continue */);
+}
+/* Thread to display periodical debug information */
+static pthread_t thr;
+static void * mn_thr(void * arg)
+{
+	sigset_t sig;
+	struct sigaction act;
+	fd_log_threadname("Monitor thread");
+	
+	/* Catch signal SIGUSR1 */
+	memset(&act, 0, sizeof(act));
+	act.sa_handler = got_sig;
+	CHECK_SYS_DO( sigaction(SIGUSR1, &act, NULL), /* conitnue */ );
+	sigemptyset(&sig);
+	sigaddset(&sig, SIGUSR1);
+	CHECK_POSIX_DO(  pthread_sigmask(SIG_UNBLOCK, &sig, NULL), /* conitnue */  );
+	
+	/* Loop */
+	while (1) {
+		sleep(60);
+		TRACE_DEBUG(NONE, "Monitor information");
+		CHECK_FCT_DO(fd_event_send(fd_g_config->cnf_main_ev, FDEV_DUMP_QUEUES, NULL), /* continue */);
+		CHECK_FCT_DO(fd_event_send(fd_g_config->cnf_main_ev, FDEV_DUMP_PEERS, NULL), /* continue */);
+		pthread_testcancel();
+	}
+	
+	return NULL;
+}
+
+static int monitor_main(char * conffile)
+{
+	TRACE_ENTRY("%p", conffile);
+	CHECK_POSIX( pthread_create( &thr, NULL, mn_thr, NULL ) );
+	return 0;
+}
+
+void fd_ext_fini(void)
+{
+	TRACE_ENTRY();
+	CHECK_FCT_DO( fd_thr_term(&thr), /* continue */ );
+	return ;
+}
+
Index: extensions/dict_eap/CMakeLists.txt
===================================================================
--- extensions/dict_eap/CMakeLists.txt	(revision 10)
+++ extensions/dict_eap/CMakeLists.txt	(revision 10)
@@ -0,0 +1,5 @@
+# The dict_nasreq extension
+PROJECT("Diameter EAP (RFC4072) dictionary definitions" C)
+
+# Compile as a module
+FD_ADD_EXTENSION(dict_eap dict_eap.c)
